﻿# Morse Code Trainer v.0 by ozurr  December 29, 2005
#
# dump this script and the 2 wav files dit800.wav and dah800.wav
# into the game folder of a 5.3.0 or later Ren,Py engine folder and rename to script.rpy
# or into a folder named data or whatever and run from a console run_game.py with that folder as option
# refer to Ren,Py docs on how to do that.
#
# This code is released into the public domain.
# This is a quick hack so it's very possible there are errors, typos, etc.
# This is NOT an example of good coding.
# Don't blame me if something goes wrong or you
# learn incorrect morse code or scripting.
# This is only a test. dahhhhhhhhhhhhhhhhhh.
#
# TODO: (sometime in 2006)
#    New Year's Resolution: learn Python, learn Ren,Py, learn SciTE, learn how to indent 
#    using wavfiles is noisy so generate tones with code so freq can be adjusted as well
#    add some more features
#    The intention is to make a study guide for the ham operators technician plus license exam,
#    but the odds of my finishing it are slim.
init:
    # Set up the size of the screen, and the window title.
    $ import random
    $ config.screen_width = 800
    $ config.screen_height = 600
    $ config.window_title = "Morse Code Trainer"

    # Backgrounds.
    image black = Solid((0, 0, 0, 255))
    image white = Solid((255, 255, 255, 255))

label main_menu:
    scene black
    show text "Morse Code Trainer v.0" with dissolve
    $ renpy.pause(1.0)
    show text "by ozurr" with dissolve
    $ renpy.pause(1.0)
    hide text with dissolve
    return

label start:
    $ renpy.clear_game_runtime()  
    scene black
    menu:
        "Info":
           jump info
        "Learn Morse Code":
           jump practice
        "Test Your Knowledge":
            jump test_main

label practice:
    
    python:
        ui.textbutton('A (alpha) .-', clicked=ui.returns('a'), text_style='button_text', xpos=20, xanchor='left',ypos=0, yanchor='top')
        ui.textbutton('B (bravo) -...', clicked=ui.returns('b'), text_style='button_text', xpos=20, xanchor='left',ypos=40, yanchor='top')
        ui.textbutton('C (charlie) -.-.', clicked=ui.returns('c'), text_style='button_text', xpos=20, xanchor='left',ypos=80, yanchor='top')
        ui.textbutton('D (delta) -..', clicked=ui.returns('d'), text_style='button_text', xpos=20, xanchor='left',ypos=120, yanchor='top')
        ui.textbutton('E (echo) .', clicked=ui.returns('e'), text_style='button_text', xpos=20, xanchor='left',ypos=160, yanchor='top')
        ui.textbutton('F (foxtrot) ..-.', clicked=ui.returns('f'), text_style='button_text', xpos=20, xanchor='left',ypos=200, yanchor='top')
        ui.textbutton('G (golf) --.', clicked=ui.returns('g'), text_style='button_text', xpos=20, xanchor='left',ypos=240, yanchor='top')
        ui.textbutton('H (hotel) ....', clicked=ui.returns('h'), text_style='button_text', xpos=20, xanchor='left',ypos=280, yanchor='top')
        ui.textbutton('I (india) ..', clicked=ui.returns('i'), text_style='button_text', xpos=20, xanchor='left',ypos=320, yanchor='top')
        ui.textbutton('J (juliet) .---', clicked=ui.returns('j'), text_style='button_text', xpos=20, xanchor='left',ypos=360, yanchor='top')
        ui.textbutton('K (kilo) -.-', clicked=ui.returns('k'), text_style='button_text', xpos=20, xanchor='left',ypos=400, yanchor='top')
        ui.textbutton('L (lima) .-..', clicked=ui.returns('l'), text_style='button_text', xpos=20, xanchor='left',ypos=440, yanchor='top')
        ui.textbutton('M (mike) --', clicked=ui.returns('m'), text_style='button_text', xpos=20, xanchor='left',ypos=480, yanchor='top')
        ui.textbutton('N (november) -.', clicked=ui.returns('n'), text_style='button_text', xpos=20, xanchor='left',ypos=520, yanchor='top')
        ui.textbutton('O (oscar) ---', clicked=ui.returns('o'), text_style='button_text', xpos=250, xanchor='left',ypos=0, yanchor='top')
        ui.textbutton('P (papa) .--.', clicked=ui.returns('p'), text_style='button_text', xpos=250, xanchor='left',ypos=40, yanchor='top')
        ui.textbutton('Q (quebec) --.-', clicked=ui.returns('q'), text_style='button_text', xpos=250, xanchor='left',ypos=80, yanchor='top')
        ui.textbutton('R (romeo) .-.', clicked=ui.returns('r'), text_style='button_text', xpos=250, xanchor='left',ypos=120, yanchor='top')
        ui.textbutton('S (sierra) ...', clicked=ui.returns('s'), text_style='button_text', xpos=250, xanchor='left',ypos=160, yanchor='top')
        ui.textbutton('T (tango) -', clicked=ui.returns('t'), text_style='button_text', xpos=250, xanchor='left',ypos=200, yanchor='top')
        ui.textbutton('U (uniform) ..-', clicked=ui.returns('u'), text_style='button_text', xpos=250, xanchor='left',ypos=240, yanchor='top')
        ui.textbutton('V (victor) ...-', clicked=ui.returns('v'), text_style='button_text', xpos=250, xanchor='left',ypos=280, yanchor='top')
        ui.textbutton('W (whiskey) .--', clicked=ui.returns('w'), text_style='button_text', xpos=250, xanchor='left',ypos=320, yanchor='top')
        ui.textbutton('X (x-ray) -..-', clicked=ui.returns('x'), text_style='button_text', xpos=250, xanchor='left',ypos=360, yanchor='top')
        ui.textbutton('Y (yankee) -.--', clicked=ui.returns('y'), text_style='button_text', xpos=250, xanchor='left',ypos=400, yanchor='top')
        ui.textbutton('Z (zulu) --..', clicked=ui.returns('z'), text_style='button_text', xpos=250, xanchor='left',ypos=440, yanchor='top')
        ui.textbutton('(.) period .-.-.-', clicked=ui.returns('.'), text_style='button_text', xpos=250, xanchor='left',ypos=480, yanchor='top')
        ui.textbutton('(,) comma --..--', clicked=ui.returns(','), text_style='button_text', xpos=250, xanchor='left',ypos=520, yanchor='top')
        ui.textbutton('(?) question mark ..--..', clicked=ui.returns('?'), text_style='button_text', xpos=520, xanchor='left',ypos=0, yanchor='top')
        ui.textbutton('(/) slash -..-.', clicked=ui.returns('/'), text_style='button_text', xpos=520, xanchor='left',ypos=40, yanchor='top')
        ui.textbutton('(") quotation mark .-..-.', clicked=ui.returns('"'), text_style='button_text', xpos=520, xanchor='left',ypos=80, yanchor='top')
        ui.textbutton('(;) semicolon -.-.-.', clicked=ui.returns(';'), text_style='button_text', xpos=520, xanchor='left',ypos=120, yanchor='top')
        ui.textbutton('1 one .----', clicked=ui.returns('1'), text_style='button_text', xpos=520, xanchor='left',ypos=160, yanchor='top')
        ui.textbutton('2 two ..---', clicked=ui.returns('2'), text_style='button_text', xpos=520, xanchor='left',ypos=200, yanchor='top')
        ui.textbutton('3 three ...--', clicked=ui.returns('3'), text_style='button_text', xpos=520, xanchor='left',ypos=240, yanchor='top')
        ui.textbutton('4 four ....-', clicked=ui.returns('4'), text_style='button_text', xpos=520, xanchor='left',ypos=280, yanchor='top')
        ui.textbutton('5 five .....', clicked=ui.returns('5'), text_style='button_text', xpos=520, xanchor='left',ypos=320, yanchor='top')
        ui.textbutton('6 six -....', clicked=ui.returns('6'), text_style='button_text', xpos=520, xanchor='left',ypos=360, yanchor='top')
        ui.textbutton('7 seven --...', clicked=ui.returns('7'), text_style='button_text', xpos=520, xanchor='left',ypos=400, yanchor='top')
        ui.textbutton('8 eight ---..', clicked=ui.returns('8'), text_style='button_text', xpos=520, xanchor='left',ypos=440, yanchor='top')
        ui.textbutton('9 nine ----.', clicked=ui.returns('9'), text_style='button_text', xpos=520, xanchor='left',ypos=480, yanchor='top')
        ui.textbutton('0 zero -----', clicked=ui.returns('0'), text_style='button_text', xpos=520, xanchor='left',ypos=520, yanchor='top')
        ui.textbutton('[Click Here to Return to Menu]', clicked=ui.returns('_'), text_style='button_text', xpos=160, xanchor='left',ypos=560, yanchor='top')
     
    $ choice = ui.interact(suppress_overlay=True) 
    if choice == 'a':
        $ playmorse(1,2,0,0,0,0)
        jump practice
    if choice == 'b':
        $ playmorse(2,1,1,1,0,0)
        jump practice
    if choice == 'c':
        $ playmorse(2,1,2,1,0,0)
        jump practice
    if choice == 'd':
        $ playmorse(2,1,1,0,0,0)
        jump practice
    if choice == 'e':
        $ playmorse(1,0,0,0,0,0)
        jump practice
    if choice == 'f':
        $ playmorse(1,1,2,1,0,0)
        jump practice
    if choice == 'g':
        $ playmorse(2,2,1,0,0,0)
        jump practice
    if choice == 'h':
        $ playmorse(1,1,1,1,0,0)
        jump practice
    if choice == 'i':
        $ playmorse(1,1,0,0,0,0)
        jump practice
    if choice == 'j':
        $ playmorse(1,2,2,2,0,0)
        jump practice
    if choice == 'k':
        $ playmorse(2,1,2,0,0,0)
        jump practice
    if choice == 'l':
        $ playmorse(1,2,1,1,0,0)
        jump practice
    if choice == 'm':
        $ playmorse(2,2,0,0,0,0)
        jump practice
    if choice == 'n':
        $ playmorse(2,1,0,0,0,0)
        jump practice
    if choice == 'o':
        $ playmorse(2,2,2,0,0,0)
        jump practice
    if choice == 'p':
        $ playmorse(1,2,2,1,0,0)
        jump practice
    if choice == 'q':
        $ playmorse(2,2,1,2,0,0)
        jump practice
    if choice == 'r':
        $ playmorse(1,2,1,0,0,0)
        jump practice
    if choice == 's':
        $ playmorse(1,1,1,0,0,0)
        jump practice
    if choice == 't':
        $ playmorse(2,0,0,0,0,0)
        jump practice
    if choice == 'u':
        $ playmorse(1,1,2,0,0,0)
        jump practice
    if choice == 'v':
        $ playmorse(1,1,1,2,0,0)
        jump practice
    if choice == 'w':
        $ playmorse(1,2,2,0,0,0)
        jump practice
    if choice == 'x':
        $ playmorse(2,1,1,2,0,0)
        jump practice
    if choice == 'y':
        $ playmorse(2,1,2,2,0,0)
        jump practice
    if choice == 'z':
        $ playmorse(2,2,1,1,0,0)
        jump practice
    if choice == '.':
        $ playmorse(1,2,1,2,1,2)
        jump practice
    if choice == '?':
        $ playmorse(1,1,2,2,1,1)
        jump practice
    if choice == ',':
        $ playmorse(2,2,1,1,2,2)
        jump practice
    if choice == '/':
        $ playmorse(2,1,1,2,1,0)
        jump practice
    if choice == '"':
        $ playmorse(1,2,1,1,2,1)
        jump practice
    if choice == ';':
        $ playmorse(2,1,2,1,2,1)
        jump practice
    if choice == '1':
        $ playmorse(1,2,2,2,2,0)
        jump practice
    if choice == '2':
        $ playmorse(1,1,2,2,2,0)
        jump practice
    if choice == '3':
        $ playmorse(1,1,1,2,2,0)
        jump practice
    if choice == '4':
        $ playmorse(1,1,1,1,2,0)
        jump practice
    if choice == '5':
        $ playmorse(1,1,1,1,1,0)
        jump practice
    if choice == '6':
        $ playmorse(2,1,1,1,1,0)
        jump practice
    if choice == '7':
        $ playmorse(2,2,1,1,1,0)
        jump practice
    if choice == '8':
        $ playmorse(2,2,2,1,1,0)
        jump practice
    if choice == '9':
        $ playmorse(2,2,2,2,1,0)
        jump practice
    if choice == '0':
        $ playmorse(2,2,2,2,2,0)
        jump practice
    if choice == '_':
        jump start

label info:
    "Some useful info should have gone here but it didn't."
    "Gremlins ate it."
    "Gremlins don't like light."
    "That's why the backgrounds are black."
    "The duration ratio of a dit to a dah is 1 to 3."
    "That means a dah is 3 times as long as a dit."
    "I knew a gremlin named Dah once."
    "It ate Dit."
    "I didn't know Dit."
    jump start 

label test_main:
    "The test will consist of 25 characters with about 2 seconds between them.  Write them down in groups of five like this: A,J5E TH1;L N6FRV"
    "Get a pen and paper and write down the character corresponding to what you hear, then at the end, click to check your results. Click When Ready to Start"
    $ results_store = []
    $ gooberwad = 0
    while gooberwad < 25:
        $ gooberwad = gooberwad + 1
        $ booger = random.randint(0,43)
        if booger == 1:
            $ playmorse(1,2,0,0,0,0)
            $ results_store.append('A')
        elif booger == 2:
            $ playmorse(2,1,1,1,0,0)
            $ results_store.append('B')
        elif booger == 3:
            $ playmorse(2,1,2,1,0,0)
            $ results_store.append('C')
        elif booger == 4:
            $ playmorse(2,1,1,0,0,0)
            $ results_store.append('D')
        elif booger == 5:
            $ playmorse(1,0,0,0,0,0)
            $ results_store.append('E')
        elif booger == 6:
            $ playmorse(1,1,2,1,0,0)
            $ results_store.append('F')
        elif booger == 7:
            $ playmorse(2,2,1,0,0,0)
            $ results_store.append('G')
        elif booger == 8:
            $ playmorse(1,1,1,1,0,0)
            $ results_store.append('H')
        elif booger == 9:
            $ playmorse(1,1,0,0,0,0)
            $ results_store.append('I')
        elif booger == 10:
            $ playmorse(1,2,2,2,0,0)
            $ results_store.append('J')
        elif booger == 11:
            $ playmorse(2,1,2,0,0,0)
            $ results_store.append('K')
        elif booger == 12:
            $ playmorse(1,2,1,1,0,0)
            $ results_store.append('L')
        elif booger == 13:
            $ playmorse(2,2,0,0,0,0)
            $ results_store.append('M')
        elif booger == 14:
            $ playmorse(2,1,0,0,0,0)
            $ results_store.append('N')
        elif booger == 15:
            $ playmorse(2,2,2,0,0,0)
            $ results_store.append('O')
        elif booger == 16:
            $ playmorse(1,2,2,1,0,0)
            $ results_store.append('P')
        elif booger == 17:
            $ playmorse(2,2,1,2,0,0)
            $ results_store.append('Q')
        elif booger == 18:
            $ playmorse(1,2,1,0,0,0)
            $ results_store.append('R')
        elif booger == 19:
            $ playmorse(1,1,1,0,0,0)
            $ results_store.append('S')
        elif booger == 20:
            $ playmorse(2,0,0,0,0,0)
            $ results_store.append('T')
        elif booger == 21:
            $ playmorse(1,1,2,0,0,0)
            $ results_store.append('U')
        elif booger == 22:
            $ playmorse(1,1,1,2,0,0)
            $ results_store.append('V')
        elif booger == 23:
            $ playmorse(1,2,2,0,0,0)
            $ results_store.append('W')
        elif booger == 24:
            $ playmorse(2,1,1,2,0,0)
            $ results_store.append('X')
        elif booger == 25:
            $ playmorse(2,1,2,2,0,0)
            $ results_store.append('Y')
        elif booger == 26:
            $ playmorse(2,2,1,1,0,0)
            $ results_store.append('Z')
        elif booger == 27:
            $ playmorse(1,2,1,2,1,2)
            $ results_store.append('.')
        elif booger == 28:
            $ playmorse(1,1,2,2,1,1)
            $ results_store.append('?')
        elif booger == 29:
            $ playmorse(2,2,1,1,2,2)
            $ results_store.append(',')
        elif booger == 30:
            $ playmorse(2,1,1,2,1,0)
            $ results_store.append('/')
        elif booger == 31:
            $ playmorse(1,2,1,1,2,1)
            $ results_store.append('"')
        elif booger == 32:
            $ playmorse(2,1,2,1,2,1)
            $ results_store.append(';')
        elif booger == 33:
            $ playmorse(1,2,2,2,2,0)
            $ results_store.append('1')
        elif booger == 34:
            $ playmorse(1,1,2,2,2,0)
            $ results_store.append('2')
        elif booger == 35:
            $ playmorse(1,1,1,2,2,0)
            $ results_store.append('3')
        elif booger == 36:
            $ playmorse(1,1,1,1,2,0)
            $ results_store.append('4')
        elif booger == 37:
            $ playmorse(1,1,1,1,1,0)
            $ results_store.append('5')
        elif booger == 38:
            $ playmorse(2,1,1,1,1,0)
            $ results_store.append('6')
        elif booger == 39:
            $ playmorse(2,2,1,1,1,0)
            $ results_store.append('7')
        elif booger == 40:
            $ playmorse(2,2,2,1,1,0)
            $ results_store.append('8')
        elif booger == 41:
            $ playmorse(2,2,2,2,1,0)
            $ results_store.append('9')
        elif booger == 42:
            $ playmorse(2,2,2,2,2,0)
            $ results_store.append('0')
        else:
            $ playmorse(1,0,0,0,0,0)
            $ results_store.append('E')
        $ renpy.pause(3.0)
        if gooberwad ==5: 
            $ results_store.append(' ')
        if gooberwad ==10:
            $ results_store.append(' ')
        if gooberwad ==15: 
            $ results_store.append(' ')
        if gooberwad ==20: 
            $ results_store.append(' ')
    $ gloops = 18
    $ goop = 0
    "Click to See Answer"
    while goop < 29:
        $ ui.text(results_store[goop], xpos=gloops, xanchor='left',ypos=200, yanchor='top')
        $ goop = goop+1
        $ gloops =gloops +24
    "Click to Return to Menu"
    $ renpy.pause(1.0)
    jump start
$ renpy.full_restart()

init:
    python:
        
        def playmorse(mc1, mc2, mc3, mc4, mc5, mc6):

                if mc1 ==2:
                    renpy.sound.queue ('dah800.wav',channel=0,clear_queue=False)
                elif mc1 ==1:
                    renpy.sound.queue ('dit800.wav',channel=0,clear_queue=False)
                if mc2 ==2:
                    renpy.sound.queue ('dah800.wav',channel=0,clear_queue=False)
                elif mc2 ==1:
                    renpy.sound.queue ('dit800.wav',channel=0,clear_queue=False)
                if mc3 ==2:
                    renpy.sound.queue ('dah800.wav',channel=0,clear_queue=False)
                elif mc3 ==1:
                    renpy.sound.queue ('dit800.wav',channel=0,clear_queue=False)
                if mc4 ==2:
                    renpy.sound.queue ('dah800.wav',channel=0,clear_queue=False)
                elif mc4 ==1:
                    renpy.sound.queue ('dit800.wav',channel=0,clear_queue=False)
                if mc5 ==2:
                    renpy.sound.queue ('dah800.wav',channel=0,clear_queue=False)
                elif mc5 ==1:
                    renpy.sound.queue ('dit800.wav',channel=0,clear_queue=False)
                if mc6 ==2:
                    renpy.sound.queue ('dah800.wav',channel=0,clear_queue=False)
                elif mc6 ==1:
                    renpy.sound.queue ('dit800.wav',channel=0,clear_queue=False)

# the end
 
